#include <stdio.h>
#include <string.h>

char g[105][105];
int prev[105][105][2];
int n,m;

int ok(int y, int x) {
	return (0<=y && y<n && 0<=x && x<m && g[y][x]=='.');
}

int vis[105][105];

int dir[4][2]={{1,0},{-1,0},{0,1},{0,-1}};

int match(int y, int x) {
	if (y==-1) return 1;
	if (vis[y][x]) return 0;
	vis[y][x]=1;
	for (int d=0;d<4;d++) {
		int y2=y+dir[d][0], x2=x+dir[d][1];
		if (!ok(y2,x2)) continue;
		if (match(prev[y2][x2][0], prev[y2][x2][1])) {
			prev[y2][x2][0]=y;
			prev[y2][x2][1]=x;
			prev[y][x][0]=y2;
			prev[y][x][1]=x2;
			return 1;
		}
	}
	return 0;
}

void flood(int y, int x,int id, int first=0) {
	if (g[y][x]!='.') return;
	g[y][x]='A'+id;
	for (int d=0;d<4;d++) {
		int y2=y+dir[d][0], x2=x+dir[d][1];
		if (!ok(y2,x2)) continue;
		if (first==1) {
			if (prev[y][x][0]!=y2 || prev[y][x][1]!=x2) continue;
		}
		flood(y2,x2,1-id,1-first);
	}	
}

#include <stdlib.h>

void gen() {
	n=100; m=100;
	printf("%d %d\n",n,m);
	for (int i=0;i<n;i++) {
		for (int j=0;j<m;j++) {
			if (rand()%3==0) printf("X"); else printf(".");
		}
		printf("\n");
	}
	printf("0 0\n");
}

int main() {
	//gen(); return 0;
	while (1) {
		scanf("%d %d",&n,&m);
		if (n==0 && m==0) break;
		for (int i=0;i<n;i++) {
			scanf("%s",g[i]);
		}
		int st=0;
		memset(prev,-1,sizeof(prev));
		for (int i=0;i<n;i++) {
			for (int j=0;j<m;j++) {
				if ((i+j)%2==0 && g[i][j]=='.' && prev[i][j][0]==-1) {
					memset(vis,0,sizeof(vis));
					st+=match(i,j);
				}
			}
		}
		for (int i=0;i<n;i++) {
			for (int j=0;j<m;j++) {
				if (g[i][j]=='.' && prev[i][j][0]==-1) flood(i,j,1);
			}
		}
		for (int i=0;i<n;i++) for (int j=0;j<m;j++) if (g[i][j]=='.') g[i][j]='A';
		for (int i=0;i<n;i++) {
			printf("%s\n",g[i]);
		}
		printf("\n");
	}
	return 0;
}
